local beql, self = beql, beql
local L = AceLibrary("AceLocale-2.2"):new("beql")
local charlist = AceLibrary("Dewdrop-2.0")

beql.TimeSinceLastUpdate = 0
beql.AniType = ""

function beql:HistoryInit()
	local nowiam = UnitName("player").."-"..GetRealmName()
	local info = {
		type = 'group',
		args = {},
	}
	local i = 0
	charlist.value = nowiam
	beqlHistoryCharacterList:SetText(string.sub(nowiam,0,string.find(nowiam,"-")-1))	
	for k, v in pairs (beql.db.profile.QuestHistory) do 
		i = i +1
		info.args[i] = {
			type = 'toggle',
			name = k,
			desc = k,
			get = function() if charlist.value == k then return true else return false end end,
			set = function() charlist.value = k beqlHistoryCharacterList:SetText(string.sub(k,0,string.find(k,"-")-1)) beql:HistoryUpdate() end,
		}
	end
	charlist:Register(beqlHistoryCharacterList, 'children', function()
	 charlist:FeedAceOptionsTable(info) 
	end)
end


function beql:HistoryCharListClick()
	if charlist:IsOpen() then
		charlist:Close()
	else
		charlist:Open(HistoryCharacterList)
	end
end

-----

function beql:HistoryToggle()
	if beql.AniType ~= "" then return end
	if beqlHistoryFrame:IsShown() then
		beqlHistoryFrame:SetAlpha(1)
		beqlHistoryFrame:SetScale(1)
		beql.AniType = "FadeIn"
	else
		beqlHistoryFrame:Show()	
		beqlHistoryFrame:SetScale(0.01)
		beqlHistoryFrame:SetAlpha(0)
		beql.AniType = "FadeOut"
		beql:HistoryUpdate()
	end
end

function beql:HistoryAnimate(elapsed)

	if beql.AniType ~= "FadeIn" and beql.AniType ~= "FadeOut" then
		return
	end

	local alpha = 0
	local scale = 0

	beql.TimeSinceLastUpdate = beql.TimeSinceLastUpdate + elapsed

	if (beql.TimeSinceLastUpdate > 0.01) then
	
		if beql.AniType ~= "FadeIn" then
			alpha = beqlHistoryFrame:GetAlpha()
			alpha = alpha + 0.05
			scale = beqlHistoryFrame:GetScale()
			scale = scale + 0.05
			beqlHistoryFrame:SetAlpha(alpha)
			if scale > 1 then scale = 1 end
			beqlHistoryFrame:SetScale(scale)
			if alpha == 1 or alpha > 1 then
				beqlHistoryFrame:SetAlpha(1)
				beqlHistoryFrame:SetScale(1)
				beqlHistoryFrame:Show()
				beql.AniType = ""
			end
		else
			alpha = beqlHistoryFrame:GetAlpha()
			alpha = alpha - 0.05
			scale = beqlHistoryFrame:GetScale()
			scale = scale - 0.05			
			beqlHistoryFrame:SetAlpha(alpha)
			if scale < 0.01 then scale = 0.01 end
			beqlHistoryFrame:SetScale(scale)			
			if alpha == 0 or alpha < 0 then
				beqlHistoryFrame:SetAlpha(0)
				beqlHistoryFrame:SetScale(0.01)			
				beqlHistoryFrame:Hide()
				beql.AniType = ""
			end
		end

		beql.TimeSinceLastUpdate = 0
	end

end

function beql:HistoryScanLog()
	local nowiam = UnitName("player").."-"..GetRealmName()
	local zone
	local questid
	local qtitle, qlevel, qtag
	
	if beql.db.profile.QuestHistory[nowiam] == nil then
		beql.db.profile.QuestHistory[nowiam] = {} 
	end
	
	-- DB
		-- Char-Server
			-- Zone
				-- QuestName
					-- QuestID
					-- QLevel
					-- IsDaily -
					-- Tag
					-- Start Date
					-- Complete Date
					-- Start Pos
					-- Complete Pos
	
	for i, zone in beqlQ:IterZones() do 
		if beql.db.profile.QuestHistory[nowiam][zone] == nil then
			beql.db.profile.QuestHistory[nowiam][zone] = {}
		end
		for i, questid in beqlQ:QuestsByZone(zone) do 
			qtitle, qlevel, qtag = beqlQ:GetQuestById(questid)
			if beql.db.profile.QuestHistory[nowiam][zone][qtitle] == nil then
				beql.db.profile.QuestHistory[nowiam][zone][qtitle] = {}
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Level = qlevel
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].StartDate = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].StartPos = 0
				beql.db.profile.QuestHistory[nowiam][zone][qtitle].Tag = qtag
				if qtag == "y" then 
					beql.db.profile.QuestHistory[nowiam][zone][qtitle].Daily = true
				else
					beql.db.profile.QuestHistory[nowiam][zone][qtitle].Daily = false
				end
			end
		end
	end
end

function beql:HistoryUpdate()
	local questIndex
	local questHistory = beql.db.profile.QuestHistory[charlist.value]
	local i,k,v
	local ListFrame
	local qTag
	local scrolloffset
	local isCollapsed
	i = 1
	controli = 0
	-- Get Max number (~50)
	FauxScrollFrame_Update(beqlHistoryListScrollFrame,50,25,14)
	scrollofset = FauxScrollFrame_GetOffset(beqlHistoryListScrollFrame)
	for k, v in pairs (questHistory) do
	-- Print the Zone
		controli = controli + 1
		if controli > scrollofset then
			if i > 25 then 
				break 
			end
			ListFrame = getglobal("beqlQuestHistoryListFrame"..i)
			ListFrame:SetText(k)
			ListFrame:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
			ListFrame:Show()
			i = i +1
			if questHistory[k].Collapsed then
				isCollapsed = true
			else
				isCollapsed = false
			end
			if ( isCollapsed ) then
				ListFrame:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
			else
				ListFrame:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up"); 
			end					
		end

	-- Check if collapsed
	-- Print the Quests in the Zone
		if not isCollapsed then
			for j, l in pairs (questHistory[k]) do
				if j ~= "Collapsed" then
					controli = controli + 1
					if controli > scrollofset then
						if i > 25 then 
							break 
						end
						ListFrame = getglobal("beqlQuestHistoryListFrame"..i)
						ListFrame:SetNormalTexture("")
						ListFrame:SetText("")
						if questHistory[k][j].Tag then
							qTag = string.upper(questHistory[k][j].Tag)
						else
							qTag = ""
						end
						ListFrame:SetText("  ["..questHistory[k][j].Level..qTag.."] "..j)
						ListFrame:SetTextColor(GetDifficultyColor(questHistory[k][j].Level).r,GetDifficultyColor(questHistory[k][j].Level).g,GetDifficultyColor(questHistory[k][j].Level).b)
						ListFrame:Show()	
						i = i +1		
					end
				end
			end
		end
		
		
	end
	--Clean Up unused ID's
	for j = i, 25 ,1 do
		ListFrame = getglobal("beqlQuestHistoryListFrame"..j)
		ListFrame:Hide()
	end
end

function beql:QuestHistoryTitleClick(arg1)
	local Name = this:GetText()
	local questHistory = beql.db.profile.QuestHistory[charlist.value]
	if not questHistory[Name] then
		return
	end
	if questHistory[Name].Collapsed then
		questHistory[Name].Collapsed = false
	else
		questHistory[Name].Collapsed = true
	end
	beql:HistoryUpdate()
end

function Beql_ScrollFrame_Update()
	beql:HistoryUpdate()
end